#!flask/bin/python
#code that creates a websocket server to notify clients that are connected with chat
#receives message from clients and sends to frontend and vice versa.
from websocket_server import WebsocketServer
import json

#these two next functions are less used, because verify when a new connection is made
#This way, set a id to each connection and treats as a new user, what is not true
#Each connection made can be or a user or a new message sent
#when a message is sent, it create a new connection and when receive response, close connection
#Thus, we can't use these functions as clients that joined in system.
def new_client(client, server):
    print("New client connected and was given id %d" % client['id'])
    
def client_left(client, server):
    print("Client(%d) disconnected" % client['id'])

#all messages are sent to all clients
#client has a JavaScript that verify whether the message is to that client or not
#messages that this method receive are messages of clients, a new client entered in room or left the room
def message_received(client, server, message):
    if len(message) > 200:
        message = message[:200]+'..'
    print("Client(%d) said: %s" % (client['id'], message))
    server.send_message_to_all(message)

#initialize server in port 5050
#indicates which function treats each feature of system
server = WebsocketServer(5050,'0.0.0.0')
server.set_fn_new_client(new_client)
server.set_fn_client_left(client_left)
server.set_fn_message_received(message_received)
server.run_forever()
